Index: kernel/test/test.c
===================================================================
--- kernel/test/test.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/test/test.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -41,4 +41,5 @@
 test_t tests[] = {
 #include <atomic/atomic1.def>
+#include <btree/btree1.def>
 #include <debug/mips1.def>
 #include <fault/fault1.def>
Index: kernel/test/test.h
===================================================================
--- kernel/test/test.h	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ kernel/test/test.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -58,4 +58,5 @@
 
 extern const char *test_atomic1(void);
+extern const char *test_btree1(void);
 extern const char *test_mips1(void);
 extern const char *test_fault1(void);
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/Makefile	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -58,5 +58,4 @@
 	app/loc \
 	app/logset \
-	app/lprint \
 	app/mixerctl \
 	app/mkfat \
@@ -167,5 +166,4 @@
 	drv/char/msim-con \
 	drv/char/ns8250 \
-	drv/char/pc-lpt \
 	drv/char/pl050 \
 	drv/char/ski-con \
@@ -276,5 +274,4 @@
 
 export: $(BUILDS)
-	mkdir -p $(EXPORT_DIR)
 	$(MAKE) -r -C lib/posix export EXPORT_DIR=$(EXPORT_DIR)
 
Index: uspace/app/mkext4/mkext4.c
===================================================================
--- uspace/app/mkext4/mkext4.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/app/mkext4/mkext4.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -56,5 +56,4 @@
 	aoff64_t nblocks;
 	const char *label = "";
-	unsigned int bsize = 4096;
 
 	cfg.version = ext4_def_fs_version;
@@ -69,5 +68,5 @@
 	++argv;
 
-	while (*argv && *argv[0] == '-') {
+	while (*argv[0] == '-') {
 		if (str_cmp(*argv, "--size") == 0) {
 			--argc;
@@ -88,26 +87,4 @@
 			--argc;
 			++argv;
-			continue;
-		}
-
-		if (str_cmp(*argv, "--bsize") == 0) {
-			--argc;
-			++argv;
-			if (*argv == NULL) {
-				printf(NAME ": Error, argument missing.\n");
-				syntax_print();
-				return 1;
-			}
-
-			bsize = strtol(*argv, &endptr, 10);
-			if (*endptr != '\0') {
-				printf(NAME ": Error, invalid argument.\n");
-				syntax_print();
-				return 1;
-			}
-
-			--argc;
-			++argv;
-			continue;
 		}
 
@@ -130,5 +107,4 @@
 			--argc;
 			++argv;
-			continue;
 		}
 
@@ -146,10 +122,4 @@
 			--argc;
 			++argv;
-			continue;
-		}
-
-		if (str_cmp(*argv, "--help") == 0) {
-			syntax_print();
-			return 0;
 		}
 
@@ -158,8 +128,4 @@
 			++argv;
 			break;
-		} else {
-			printf(NAME ": Invalid argument: %s\n", *argv);
-			syntax_print();
-			return 1;
 		}
 	}
@@ -181,5 +147,4 @@
 
 	cfg.volume_name = label;
-	cfg.bsize = bsize;
 	(void) nblocks;
 
@@ -201,6 +166,5 @@
 	    "\t--size <sectors> Filesystem size, overrides device size\n"
 	    "\t--label <label>  Volume label\n"
-	    "\t--type <fstype>  Filesystem type (ext2, ext2old)\n"
-	    "\t--bsize <bytes>  Filesystem block size in bytes (default = 4096)\n");
+	    "\t--type <fstype>  Filesystem type (ext2, ext2old)\n");
 }
 
Index: uspace/app/modplay/modplay.c
===================================================================
--- uspace/app/modplay/modplay.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/app/modplay/modplay.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -39,5 +39,4 @@
 #include <stdio.h>
 #include <stdlib.h>
-#include <str.h>
 #include <str_error.h>
 #include <trackmod.h>
@@ -68,11 +67,4 @@
 }
 
-static void print_syntax(void)
-{
-	printf("syntax: modplay [<options>] <filename.mod>\n");
-	printf("options:\n");
-	printf("\t-t <target>\tOutput to specified audio target.\n");
-}
-
 int main(int argc, char *argv[])
 {
@@ -86,33 +78,8 @@
 	void *buffer;
 	size_t buffer_size;
-	const char *target = HOUND_DEFAULT_TARGET;
 	errno_t rc;
 
-	++argv;
-	--argc;
-
-	while (argc > 0 && (*argv)[0] == '-') {
-		if (str_cmp(*argv, "-t") == 0) {
-			++argv;
-			--argc;
-
-			if (argc < 1) {
-				printf("Option '-t' requires an argument.\n");
-				print_syntax();
-				return 1;
-			}
-
-			target = *argv++;
-			--argc;
-			continue;
-		}
-
-		printf("Invalid option '%s'\n", *argv);
-		print_syntax();
-		return 1;
-	}
-
-	if (argc != 1) {
-		print_syntax();
+	if (argc != 2) {
+		printf("syntax: modplay <filename.mod>\n");
 		return 1;
 	}
@@ -120,7 +87,7 @@
 	con = console_init(stdin, stdout);
 
-	rc = trackmod_module_load(argv[0], &mod);
+	rc = trackmod_module_load(argv[1], &mod);
 	if (rc != EOK) {
-		printf("Error loading %s.\n", argv[0]);
+		printf("Error loading %s.\n", argv[1]);
 		return 1;
 	}
@@ -147,18 +114,7 @@
 	}
 
-	rc = hound_context_connect_target(hound, target);
+	rc = hound_context_connect_target(hound, HOUND_DEFAULT_TARGET);
 	if (rc != EOK) {
-		printf("Error connecting audio target '%s': %s.\n",
-		    target, str_error(rc));
-
-		char **names = NULL;
-		size_t count = 0;
-		rc = hound_context_get_available_targets(hound, &names, &count);
-		if (rc == EOK) {
-			printf("Available targets:\n");
-			for (size_t i = 0; i < count; i++)
-				printf(" - %s\n", names[i]);
-		}
-
+		printf("Error connecting default audio target: %s.\n", str_error(rc));
 		return 1;
 	}
Index: uspace/app/sysinst/sysinst.c
===================================================================
--- uspace/app/sysinst/sysinst.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/app/sysinst/sysinst.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -62,5 +62,5 @@
  * in Grub notation).
  */
-#define DEFAULT_DEV "devices/\\hw\\sys\\00:01.0\\ata-c1\\d0"
+#define DEFAULT_DEV "devices/\\hw\\pci0\\00:01.0\\ata-c1\\d0"
 //#define DEFAULT_DEV "devices/\\hw\\pci0\\00:01.2\\uhci_rh\\usb01_a1\\mass-storage0\\l0"
 /** Volume label for the new file system */
Index: uspace/app/wavplay/main.c
===================================================================
--- uspace/app/wavplay/main.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/app/wavplay/main.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -119,5 +119,5 @@
  * @return Error code
  */
-static errno_t hplay(const char *filename, const char *target)
+static errno_t hplay(const char *filename)
 {
 	printf("Hound playback: %s\n", filename);
@@ -158,18 +158,8 @@
 	}
 
-	ret = hound_context_connect_target(hound, target);
+	ret = hound_context_connect_target(hound, HOUND_DEFAULT_TARGET);
 	if (ret != EOK) {
-		printf("Failed to connect to target '%s': %s\n", target,
+		printf("Failed to connect to default target: %s\n",
 		    str_error(ret));
-
-		char **names = NULL;
-		size_t count = 0;
-		ret = hound_context_get_available_targets(hound, &names, &count);
-		if (ret == EOK) {
-			printf("Available targets:\n");
-			for (size_t i = 0; i < count; i++)
-				printf(" - %s\n", names[i]);
-		}
-
 		hound_context_destroy(hound);
 		fclose(source);
@@ -225,5 +215,4 @@
 	{ "parallel", no_argument, 0, 'p' },
 	{ "record", no_argument, 0, 'r' },
-	{ "target", required_argument, 0, 't' },
 	{ "help", no_argument, 0, 'h' },
 	{ 0, 0, 0, 0 }
@@ -241,7 +230,6 @@
 	printf("\t -r, --record\t Start recording instead of playback. "
 	    "(Not implemented)\n");
-	printf("\t -d, --device\t Direct output to specified device instead of "
-	    "the sound service. Use location path or a special device `default'\n");
-	printf("\t -t, --target\t Output to the specified audio target.\n");
+	printf("\t -d, --device\t Use specified device instead of the sound "
+	    "service. Use location path or a special device `default'\n");
 	printf("\t -p, --parallel\t Play given files in parallel instead of "
 	    "sequentially (does not work with -d).\n");
@@ -251,5 +239,4 @@
 {
 	const char *device = "default";
-	const char *target = HOUND_DEFAULT_TARGET;
 	int idx = 0;
 	bool direct = false, record = false, parallel = false;
@@ -259,5 +246,5 @@
 	/* Parse command line options */
 	while (ret != -1) {
-		ret = getopt_long(argc, argv, "d:prt:h", opts, &idx);
+		ret = getopt_long(argc, argv, "d:prh", opts, &idx);
 		switch (ret) {
 		case 'd':
@@ -270,7 +257,4 @@
 		case 'p':
 			parallel = true;
-			break;
-		case 't':
-			target = optarg;
 			break;
 		case 'h':
@@ -350,5 +334,5 @@
 				fibril_add_ready(fid);
 			} else {
-				hplay(file, target);
+				hplay(file);
 			}
 		}
Index: uspace/doc/main_page.h
===================================================================
--- uspace/doc/main_page.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
+++ uspace/doc/main_page.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -0,0 +1,12 @@
+/**
+ * @mainpage HelenOS Operating System Source Code Reference
+ *
+ * HelenOS is a portable microkernel-based multiserver operating system designed and implemented from scratch. It decomposes key operating system functionality such as file systems, networking, device drivers and graphical user interface into a collection of fine-grained user space components that interact with each other via message passing. A failure or crash of one component does not directly harm others. HelenOS is therefore flexible, modular, extensible, fault tolerant and easy to understand.
+ *
+ * HelenOS does not aim to be a clone of any existing operating system and trades compatibility with legacy APIs for cleaner design. Most of HelenOS components have been made to order specifically for HelenOS so that its essential parts can stay free of adaptation layers, glue code, franken-components and the maintenance burden incurred by them.
+ *
+ * HelenOS runs on seven different processor architectures and machines ranging from embedded ARM devices and single-board computers through multicore 32-bit and 64-bit desktop PCs to 64-bit Itanium and SPARC rack-mount servers.
+ *
+ * HelenOS is open source, free software. Its source code is available under the BSD license. Some third-party components are licensed under GPL.
+ *
+ */
Index: uspace/drv/audio/hdaudio/hdaudio.c
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/audio/hdaudio/hdaudio.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -151,5 +151,4 @@
 {
 	ddf_fun_t *fun_pcm = NULL;
-	bool bound = false;
 	hda_t *hda = NULL;
 	hw_res_list_parsed_t res;
@@ -300,17 +299,9 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun_pcm, "audio-pcm");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding function to audio-pcm category.");
-		goto error;
-	}
+	ddf_fun_add_to_category(fun_pcm, "audio-pcm");
 
 	hw_res_list_parsed_clean(&res);
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun_pcm);
 	if (fun_pcm != NULL)
 		ddf_fun_destroy(fun_pcm);
Index: uspace/drv/audio/hdaudio/hdaudio.ma
===================================================================
--- uspace/drv/audio/hdaudio/hdaudio.ma	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/audio/hdaudio/hdaudio.ma	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -1,4 +1,3 @@
 10 pci/ven=1002&dev=4383
-10 pci/ven=8086&dev=160c
 10 pci/ven=8086&dev=1e20
 10 pci/ven=8086&dev=2668
@@ -6,3 +5,2 @@
 10 pci/ven=8086&dev=1c20
 10 pci/ven=8086&dev=293e
-10 pci/ven=8086&dev=9ca0
Index: uspace/drv/block/ata_bd/main.c
===================================================================
--- uspace/drv/block/ata_bd/main.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/block/ata_bd/main.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -162,5 +162,4 @@
 	ddf_fun_t *fun = NULL;
 	ata_fun_t *afun = NULL;
-	bool bound = false;
 
 	fun_name = ata_fun_name(disk);
@@ -203,12 +202,5 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, "disk");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding function %s to "
-		    "category 'disk': %s", fun_name, str_error(rc));
-		goto error;
-	}
+	ddf_fun_add_to_category(fun, "disk");
 
 	free(fun_name);
@@ -216,6 +208,4 @@
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun);
 	if (fun != NULL)
 		ddf_fun_destroy(fun);
Index: uspace/drv/block/ddisk/ddisk.c
===================================================================
--- uspace/drv/block/ddisk/ddisk.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/block/ddisk/ddisk.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -319,5 +319,4 @@
 	errno_t rc;
 	ddf_fun_t *fun = NULL;
-	bool bound = false;
 
 	fun = ddf_fun_create(ddisk->dev, fun_exposed, DDISK_FUN_NAME);
@@ -338,18 +337,9 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, "disk");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding function %s to category "
-		    "'disk': %s.\n", DDISK_FUN_NAME, str_error(rc));
-		goto error;
-	}
+	ddf_fun_add_to_category(fun, "disk");
 	ddisk->fun = fun;
 
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun);
 	if (fun != NULL)
 		ddf_fun_destroy(fun);
Index: uspace/drv/block/usbmast/main.c
===================================================================
--- uspace/drv/block/usbmast/main.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/block/usbmast/main.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -223,5 +223,4 @@
 	ddf_fun_t *fun = NULL;
 	usbmast_fun_t *mfun = NULL;
-	bool bound = false;
 
 	if (asprintf(&fun_name, "l%u", lun) < 0) {
@@ -300,12 +299,5 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, "disk");
-	if (rc != EOK) {
-		usb_log_error("Failed to add function %s to category 'disk': %s.",
-		    fun_name, str_error(rc));
-		goto error;
-	}
+	ddf_fun_add_to_category(fun, "disk");
 
 	free(fun_name);
@@ -316,6 +308,4 @@
 	/* Error cleanup */
 error:
-	if (bound)
-		ddf_fun_unbind(fun);
 	if (fun != NULL)
 		ddf_fun_destroy(fun);
Index: uspace/drv/bus/isa/isa.dev
===================================================================
--- uspace/drv/bus/isa/isa.dev	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/bus/isa/isa.dev	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -17,14 +17,4 @@
 	irq 3
 	io_range 2f8 8
-
-lpt1:
-	match 100 isa/lpt
-	io_range 378 8
-	irq 7
-
-lpt2:
-	match 100 isa/lpt
-	io_range 278 8
-	irq 5
 
 i8042:
Index: uspace/drv/char/msim-con/msim-con.c
===================================================================
--- uspace/drv/char/msim-con/msim-con.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/char/msim-con/msim-con.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -85,5 +85,4 @@
 	irq_cmd_t *msim_cmds = NULL;
 	errno_t rc;
-	bool bound = false;
 
 	circ_buf_init(&con->cbuf, con->buf, msim_con_buf_size, 1);
@@ -144,12 +143,5 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, "console");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error adding function 'a' to category "
-		    "'console'.");
-		goto error;
-	}
+	ddf_fun_add_to_category(fun, "console");
 
 	return EOK;
@@ -157,6 +149,4 @@
 	if (CAP_HANDLE_VALID(con->irq_handle))
 		async_irq_unsubscribe(con->irq_handle);
-	if (bound)
-		ddf_fun_unbind(fun);
 	if (fun != NULL)
 		ddf_fun_destroy(fun);
Index: uspace/drv/char/ns8250/ns8250.c
===================================================================
--- uspace/drv/char/ns8250/ns8250.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/char/ns8250/ns8250.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -829,5 +829,4 @@
 	bool need_cleanup = false;
 	bool need_unreg_intr_handler = false;
-	bool bound = false;
 	errno_t rc;
 
@@ -910,12 +909,7 @@
 	}
 
-	bound = true;
 	ns->fun = fun;
 
-	rc = ddf_fun_add_to_category(fun, "serial");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error adding function to category 'serial'.");
-		goto fail;
-	}
+	ddf_fun_add_to_category(fun, "serial");
 
 	ddf_msg(LVL_NOTE, "Device %s successfully initialized.",
@@ -924,6 +918,4 @@
 	return EOK;
 fail:
-	if (bound)
-		ddf_fun_unbind(fun);
 	if (fun != NULL)
 		ddf_fun_destroy(fun);
Index: uspace/drv/char/ski-con/ski-con.c
===================================================================
--- uspace/drv/char/ski-con/ski-con.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/char/ski-con/ski-con.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -112,12 +112,7 @@
 	}
 
+	ddf_fun_add_to_category(fun, "console");
+
 	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, "console");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error adding function 'a' to category "
-		    "'console'.");
-		goto error;
-	}
 
 	fid = fibril_create(ski_con_fibril, con);
Index: uspace/drv/char/sun4v-con/sun4v-con.c
===================================================================
--- uspace/drv/char/sun4v-con/sun4v-con.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/char/sun4v-con/sun4v-con.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -74,5 +74,4 @@
 	ddf_fun_t *fun = NULL;
 	errno_t rc;
-	bool bound = false;
 
 	con->res = *res;
@@ -114,12 +113,5 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, "console");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Error adding function 'a' to category "
-		    "'console'.");
-		goto error;
-	}
+	ddf_fun_add_to_category(fun, "console");
 
 	return EOK;
@@ -130,7 +122,4 @@
 	if (con->output_buffer != (niagara_output_buffer_t *) AS_AREA_ANY)
 		physmem_unmap((void *) con->output_buffer);
-
-	if (bound)
-		ddf_fun_unbind(fun);
 
 	if (fun != NULL)
Index: uspace/drv/fb/amdm37x_dispc/main.c
===================================================================
--- uspace/drv/fb/amdm37x_dispc/main.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/fb/amdm37x_dispc/main.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -60,5 +60,5 @@
 	ddf_fun_t *fun = ddf_fun_create(dev, fun_exposed, "viz");
 	if (!fun) {
-		ddf_log_error("Failed to create visualizer function.");
+		ddf_log_error("Failed to create visualizer function\n");
 		return ENOMEM;
 	}
@@ -66,5 +66,5 @@
 	visualizer_t *vis = ddf_fun_data_alloc(fun, sizeof(visualizer_t));
 	if (!vis) {
-		ddf_log_error("Failed to allocate visualizer structure.");
+		ddf_log_error("Failed to allocate visualizer structure\n");
 		ddf_fun_destroy(fun);
 		return ENOMEM;
@@ -79,36 +79,27 @@
 	    ddf_dev_data_alloc(dev, sizeof(amdm37x_dispc_t));
 	if (!dispc) {
-		ddf_log_error("Failed to allocate dispc structure.");
+		ddf_log_error("Failed to allocate dispc structure\n");
 		ddf_fun_destroy(fun);
 		return ENOMEM;
 	}
 
-	errno_t rc = amdm37x_dispc_init(dispc, vis);
-	if (rc != EOK) {
-		ddf_log_error("Failed to init dispc: %s.", str_error(rc));
+	errno_t ret = amdm37x_dispc_init(dispc, vis);
+	if (ret != EOK) {
+		ddf_log_error("Failed to init dispc: %s\n", str_error(ret));
 		ddf_fun_destroy(fun);
-		return rc;
+		return ret;
 	}
 
 	/* Bind function */
-	rc = ddf_fun_bind(fun);
-	if (rc != EOK) {
-		ddf_log_error("Failed to bind function: %s.", str_error(rc));
+	ret = ddf_fun_bind(fun);
+	if (ret != EOK) {
+		ddf_log_error("Failed to bind function: %s\n", str_error(ret));
 		amdm37x_dispc_fini(dispc);
 		ddf_fun_destroy(fun);
-		return rc;
+		return ret;
 	}
+	ddf_fun_add_to_category(fun, "visualizer");
 
-	rc = ddf_fun_add_to_category(fun, "visualizer");
-	if (rc != EOK) {
-		ddf_log_error("Failed to add function: %s to visualizer "
-		    "category.", str_error(rc));
-		amdm37x_dispc_fini(dispc);
-		ddf_fun_unbind(fun);
-		ddf_fun_destroy(fun);
-		return rc;
-	}
-
-	ddf_log_note("Added device `%s'", ddf_dev_get_name(dev));
+	ddf_log_note("Added device `%s'\n", ddf_dev_get_name(dev));
 	return EOK;
 }
Index: uspace/drv/fb/kfb/port.c
===================================================================
--- uspace/drv/fb/kfb/port.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/fb/kfb/port.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -348,12 +348,5 @@
 
 	vs->reg_svc_handle = ddf_fun_get_handle(fun_vs);
-	rc = ddf_fun_add_to_category(fun_vs, "visualizer");
-	if (rc != EOK) {
-		list_remove(&pixel_mode.link);
-		ddf_fun_unbind(fun_vs);
-		ddf_fun_destroy(fun_vs);
-		as_area_destroy(kfb.addr);
-		return rc;
-	}
+	ddf_fun_add_to_category(fun_vs, "visualizer");
 
 	return EOK;
Index: uspace/drv/intctl/apic/apic.c
===================================================================
--- uspace/drv/intctl/apic/apic.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/intctl/apic/apic.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -212,5 +212,4 @@
 	void *regs;
 	errno_t rc;
-	bool bound = false;
 
 	if ((sysinfo_get_value("apic", &have_apic) != EOK) || (!have_apic)) {
@@ -242,6 +241,4 @@
 	}
 
-	bound = true;
-
 	rc = ddf_fun_add_to_category(fun_a, "irc");
 	if (rc != EOK)
@@ -250,6 +247,4 @@
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun_a);
 	if (fun_a != NULL)
 		ddf_fun_destroy(fun_a);
Index: uspace/drv/intctl/i8259/i8259.c
===================================================================
--- uspace/drv/intctl/i8259/i8259.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/intctl/i8259/i8259.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -142,5 +142,4 @@
 	ddf_fun_t *fun_a = NULL;
 	errno_t rc;
-	bool bound = false;
 
 	if ((sysinfo_get_value("i8259", &have_i8259) != EOK) || (!have_i8259)) {
@@ -175,6 +174,4 @@
 	}
 
-	bound = true;
-
 	rc = ddf_fun_add_to_category(fun_a, "irc");
 	if (rc != EOK)
@@ -183,6 +180,4 @@
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun_a);
 	if (fun_a != NULL)
 		ddf_fun_destroy(fun_a);
Index: uspace/drv/intctl/icp-ic/icp-ic.c
===================================================================
--- uspace/drv/intctl/icp-ic/icp-ic.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/intctl/icp-ic/icp-ic.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -116,5 +116,4 @@
 	void *regs;
 	errno_t rc;
-	bool bound = false;
 
 	rc = pio_enable((void *)res->base, sizeof(icpic_regs_t), &regs);
@@ -147,6 +146,4 @@
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun_a);
 	if (fun_a != NULL)
 		ddf_fun_destroy(fun_a);
Index: uspace/drv/intctl/obio/obio.c
===================================================================
--- uspace/drv/intctl/obio/obio.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/intctl/obio/obio.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -118,5 +118,4 @@
 	ddf_fun_t *fun_a = NULL;
 	errno_t rc;
-	bool bound = false;
 
 	rc = pio_enable((void *)res->base, OBIO_SIZE, (void **) &obio->regs);
@@ -150,6 +149,4 @@
 	return EOK;
 error:
-	if (bound)
-		ddf_fun_unbind(fun_a);
 	if (fun_a != NULL)
 		ddf_fun_destroy(fun_a);
Index: uspace/drv/test/test1/test1.c
===================================================================
--- uspace/drv/test/test1/test1.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/test/test1/test1.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -176,12 +176,5 @@
 	}
 
-	rc = ddf_fun_add_to_category(fun_a, "virtual");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding function 'a' to category "
-		    "'virtual'.");
-		ddf_fun_unbind(fun_a);
-		ddf_fun_destroy(fun_a);
-		goto error;
-	}
+	ddf_fun_add_to_category(fun_a, "virtual");
 
 	if (str_cmp(dev_name, "test1") == 0) {
Index: uspace/drv/test/test2/test2.c
===================================================================
--- uspace/drv/test/test2/test2.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/test/test2/test2.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -140,18 +140,9 @@
 	rc = ddf_fun_bind(fun_a);
 	if (rc != EOK) {
-		ddf_fun_destroy(fun_a);
 		ddf_msg(LVL_ERROR, "Failed binding function 'a'.");
 		return rc;
 	}
 
-	rc = ddf_fun_add_to_category(fun_a, "virtual");
-	if (rc != EOK) {
-		ddf_fun_unbind(fun_a);
-		ddf_fun_destroy(fun_a);
-		ddf_msg(LVL_ERROR, "Failed adding function 'a' to category "
-		    "'virtual'.");
-		return rc;
-	}
-
+	ddf_fun_add_to_category(fun_a, "virtual");
 	test2->fun_a = fun_a;
 
Index: uspace/drv/test/test3/test3.c
===================================================================
--- uspace/drv/test/test3/test3.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/test/test3/test3.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -70,5 +70,4 @@
 	errno_t rc;
 	char *fun_name = NULL;
-	bool bound = false;
 
 	if (asprintf(&fun_name, "%s%zu", base_name, index) < 0) {
@@ -92,12 +91,5 @@
 	}
 
-	bound = true;
-
-	rc = ddf_fun_add_to_category(fun, class_name);
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed addning function %s to category %s: "
-		    "%s", fun_name, class_name, str_error(rc));
-		goto leave;
-	}
+	ddf_fun_add_to_category(fun, class_name);
 
 	ddf_msg(LVL_NOTE, "Registered exposed function `%s'.", fun_name);
@@ -106,6 +98,4 @@
 	free(fun_name);
 
-	if (bound)
-		ddf_fun_unbind(fun);
 	if ((rc != EOK) && (fun != NULL)) {
 		ddf_fun_destroy(fun);
Index: uspace/drv/time/cmos-rtc/cmos-rtc.c
===================================================================
--- uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/drv/time/cmos-rtc/cmos-rtc.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -588,5 +588,4 @@
 	errno_t rc;
 	bool need_cleanup = false;
-	bool bound = false;
 
 	ddf_msg(LVL_DEBUG, "rtc_dev_add %s (handle = %d)",
@@ -625,12 +624,7 @@
 	}
 
-	bound = true;
 	rtc->fun = fun;
 
-	rc = ddf_fun_add_to_category(fun, "clock");
-	if (rc != EOK) {
-		ddf_msg(LVL_ERROR, "Failed adding service to clock category.");
-		goto error;
-	}
+	ddf_fun_add_to_category(fun, "clock");
 
 	ddf_msg(LVL_NOTE, "Device %s successfully initialized",
@@ -640,6 +634,4 @@
 
 error:
-	if (bound)
-		ddf_fun_unbind(fun);
 	if (fun)
 		ddf_fun_destroy(fun);
@@ -762,8 +754,6 @@
 
 	rc = ddf_fun_online(fun);
-	if (rc == EOK) {
-		// XXX This should be probably handled by the framework
-		rc = ddf_fun_add_to_category(fun, "clock");
-	}
+	if (rc == EOK)
+		ddf_fun_add_to_category(fun, "clock");
 
 	return rc;
Index: uspace/lib/c/generic/async/server.c
===================================================================
--- uspace/lib/c/generic/async/server.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/c/generic/async/server.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -871,6 +871,4 @@
 
 		memset(call, 0, sizeof(ipc_call_t));
-		IPC_SET_IMETHOD(*call, IPC_M_PHONE_HUNGUP);
-		call->cap_handle = CAP_NIL;
 	}
 
Index: uspace/lib/drv/generic/driver.c
===================================================================
--- uspace/lib/drv/generic/driver.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/drv/generic/driver.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -526,6 +526,4 @@
 		return NULL;
 
-	refcount_init(&dev->refcnt);
-
 	return dev;
 }
@@ -543,5 +541,4 @@
 		return NULL;
 
-	refcount_init(&fun->refcnt);
 	init_match_ids(&fun->match_ids);
 	link_initialize(&fun->link);
Index: uspace/lib/drv/generic/remote_audio_pcm.c
===================================================================
--- uspace/lib/drv/generic/remote_audio_pcm.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/drv/generic/remote_audio_pcm.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -142,9 +142,9 @@
 audio_pcm_sess_t *audio_pcm_open(const char *name)
 {
-	service_id_t sid;
-	const errno_t ret = loc_service_get_id(name, &sid, 0);
+	devman_handle_t device_handle = 0;
+	const errno_t ret = devman_fun_get_handle(name, &device_handle, 0);
 	if (ret != EOK)
 		return NULL;
-	return loc_service_connect(sid, INTERFACE_DDF, 0);
+	return devman_device_connect(device_handle, IPC_FLAG_BLOCKING);
 }
 
Index: uspace/lib/ext4/include/ext4/cfg.h
===================================================================
--- uspace/lib/ext4/include/ext4/cfg.h	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ext4/include/ext4/cfg.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -53,6 +53,4 @@
 	/** Volume name encoded as UTF-8 string */
 	const char *volume_name;
-	/** Filesystem block size */
-	size_t bsize;
 } ext4_cfg_t;
 
Index: uspace/lib/ext4/include/ext4/superblock.h
===================================================================
--- uspace/lib/ext4/include/ext4/superblock.h	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ext4/include/ext4/superblock.h	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -147,5 +147,4 @@
 extern void ext4_superblock_set_reserved_gdt_blocks(ext4_superblock_t *sb,
     uint32_t n);
-extern uint32_t ext4_superblock_get_flex_group_size(ext4_superblock_t *sb);
 
 /* More complex superblock functions */
Index: uspace/lib/ext4/src/balloc.c
===================================================================
--- uspace/lib/ext4/src/balloc.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ext4/src/balloc.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -261,28 +261,32 @@
 		 * is always after the inode table.
 		 */
-		return itable + itable_sz;
-	}
-
-	uint32_t flex_group_size = ext4_superblock_get_flex_group_size(sb);
-	if ((bg_ref->index % flex_group_size) == 0) {
-		/* This is the base group */
-		uint32_t i;
-
 		r = itable + itable_sz;
-
-		uint32_t total_groups = ext4_superblock_get_block_group_count(sb);
-		for (i = bg_ref->index + 1;
-		    i < min(total_groups, bg_ref->index + flex_group_size); ++i) {
-			r += ext4_filesystem_bg_get_itable_size(sb, i);
-		}
-
-		return r;
-	}
-
-	uint64_t base_addr = ext4_filesystem_index_in_group2blockaddr(sb, 0,
-	    bg_ref->index);
-	uint32_t reserved = ext4_filesystem_bg_get_backup_blocks(bg_ref);
-
-	return base_addr + reserved;
+		return ext4_filesystem_blockaddr2_index_in_group(sb, r);
+	}
+
+	uint64_t bbmap = ext4_block_group_get_block_bitmap(bg_ref->block_group,
+	    sb);
+	uint64_t ibmap = ext4_block_group_get_inode_bitmap(bg_ref->block_group,
+	    sb);
+
+	r = ext4_filesystem_index_in_group2blockaddr(sb, 0, bg_ref->index);
+	r += ext4_filesystem_bg_get_backup_blocks(bg_ref);
+
+	if (ext4_filesystem_blockaddr2group(sb, bbmap) != bg_ref->index)
+		bbmap = -1; /* Invalid */
+
+	if (ext4_filesystem_blockaddr2group(sb, ibmap) != bg_ref->index)
+		ibmap = -1;
+
+	while (true) {
+		if (r == bbmap || r == ibmap)
+			r++;
+		else if (r >= itable && r < (itable + itable_sz))
+			r = itable + itable_sz;
+		else
+			break;
+	}
+
+	return r;
 }
 
Index: uspace/lib/ext4/src/filesystem.c
===================================================================
--- uspace/lib/ext4/src/filesystem.c	(revision 59564e6d329e6a3146eea28acf2e3f71d2272a65)
+++ uspace/lib/ext4/src/filesystem.c	(revision cb15b49c1b1435f2f8f4b04d58fe1e1e8c4d65dd)
@@ -421,5 +421,4 @@
     enum cache_mode cmode, aoff64_t *size, ext4_filesystem_t **rfs)
 {
-	int fs_inited = 0;
 	ext4_filesystem_t *fs = NULL;
 	fs_node_t *root_node = NULL;
@@ -438,6 +437,4 @@
 	if (rc != EOK)
 		goto error;
-
-	fs_inited = 1;
 
 	/* Read root node */
@@ -466,7 +463,9 @@
 		ext4_node_put(root_node);
 
-	if (fs_inited)
+	if (fs != NULL) {
 		ext4_filesystem_fini(fs);
-	free(fs);
+		free(fs);
+	}
+
 	return rc;
 }
@@ -715,4 +714,6 @@
 		/* One for block bitmap one for inode bitmap */
 		free_blocks = free_blocks - reserved - 2 - inode_table_blocks;
+		if (bg_index == 0)
+			++free_blocks; /* XXX Why? */
 
 		ext4_block_group_set_free_blocks_count(bg_ref->block_group,
